/* Copyright 2014 Marcus Wichelmann
*
* This file is part of evnc.
*
* evnc is free software: you can redistribute it
* and/or modify it under the terms of the GNU General Public License as
* published by the Free Software Foundation, either version 3 of the
* License, or (at your option) any later version.
*
* evnc is distributed in the hope that it will be
* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
* Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with evnc. If not, see http://www.gnu.org/licenses/.
*/

namespace evnc.Widgets {
	public class Information : Gtk.InfoBar {
		public Information () {
			// Hide the bar
			this.set_no_show_all (true);
			this.set_visible (false);
		}

		public void show_text (Gtk.MessageType info_type, string info_message) {
			this.set_no_show_all (false);
			this.set_visible (true);

			// Remove old objects
			((Gtk.Box)this.get_content_area ()).get_children ().foreach ((widg) => {
				if (widg != null)
					widg.destroy ();
			});

			this.set_message_type (info_type);

			var info_label = new Gtk.Label (info_message);
			info_label.ellipsize = Pango.EllipsizeMode.END;
			info_label.use_markup = true;
			info_label.set_markup (info_message);

			var info_container = this.get_content_area () as Gtk.Box;
			info_container.orientation = Gtk.Orientation.HORIZONTAL;
			info_container.pack_start (info_label, false, false, 0);

			this.set_show_close_button (true);

			// Close Event
			this.response.connect (() => {
				this.set_no_show_all (true);
				this.set_visible (false);
			});

			this.show_all ();

			Timeout.add (5000, () => {
				this.set_no_show_all (true);
				this.set_visible (false);
				return false;
			}, Priority.DEFAULT);
		}
	}
}