/* Copyright 2014 Marcus Wichelmann
*
* This file is part of evnc.
*
* evnc is free software: you can redistribute it
* and/or modify it under the terms of the GNU General Public License as
* published by the Free Software Foundation, either version 3 of the
* License, or (at your option) any later version.
*
* evnc is distributed in the hope that it will be
* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
* Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with evnc. If not, see http://www.gnu.org/licenses/.
*/

namespace evnc.Widgets {
	public class Notebook : Granite.Widgets.DynamicNotebook {
		public signal void on_connection_message (Gtk.MessageType info_type, string info_message);

		public Notebook () {
			this.allow_drag = true;
			this.show_all ();
			this.tab_removed.connect ((tab) => {
				(tab as Widgets.VncConnection).display.close ();
			});
		}

		public void add_connection (string host, string port, string user) {
			var connection = new Widgets.VncConnection (host, port, user);
			connection.display.vnc_auth_failure.connect (() => {
				on_connection_message (Gtk.MessageType.ERROR, _("Authentification failed. Wrong username or password?"));
			});
			connection.display.vnc_auth_unsupported.connect (() => {
				on_connection_message (Gtk.MessageType.ERROR, _("Authentification not supported!"));
			});
			connection.on_save_screenshot_exception.connect ((message) => {
				on_connection_message (Gtk.MessageType.ERROR, message);
			});

			this.insert_tab (connection, -1 );
			this.current = connection;
		}
	}
}